#include <stdio.h>
#include <stdlib.h>

struct drvo {
	int broj;
	int treca_cifra;
	struct drvo *levi, *desni;
};

void ispis(struct drvo *p)
{
	if(p)
	{
		ispis(p->desni);
		printf("%5d, %5d\n", p->broj, p->treca_cifra);
		ispis(p->levi);
	}
}

void dodaj(struct drvo **p, struct drvo *temp)
{
	struct drvo *pom2, *pom1;
	pom1=*p;
	if(!pom1)
	{
		(*p)=temp;
	}
	else
	{
		if(temp->treca_cifra<pom1->treca_cifra)
			dodaj(&(pom1->levi), temp);
		else
			dodaj(&(pom1->desni), temp);
	}
}

struct drvo* form( struct drvo *p)
{
	struct drvo *pom;
	int n,i,b;
	printf("Unesi B: ");
	scanf("%d", &b);
	for (i=0;i<b;i++)
	{
		pom = (struct drvo *)malloc(sizeof(struct drvo));
		printf("Unesi BROJ: ");
		scanf("%d",&n);
		pom->broj=n;
		if((n/100)!=0)
			if((n/1000)!=0)
				pom->treca_cifra=((n/100)%10);
			else
				pom->treca_cifra=n/100;
		else
			pom->treca_cifra=0;
		pom->levi=pom->desni=NULL;
		dodaj(&p, pom);
	}
	return p;
}

int brojanje(struct drvo *p, int x)
{
	struct drvo *pom;
	int i,s=0;
	if(p)
		{
			if((p->broj<x)&&(p->treca_cifra>2)&&(p->treca_cifra<8))
				s++;
			if(p->treca_cifra>2)
				s=s+brojanje(p->levi,x);
			if(p->treca_cifra<8)
				s=s+brojanje(p->desni,x);
		}
 return s;
} 

main()
{
	struct drvo *p=NULL;
	int x;
	p=form(p);
	ispis(p);
	printf("\n");
	printf("Unesi X:");
	scanf("%d",&x);
	printf("Manjih od x sa ciframa izmedju 2 i 8 ima: %d",brojanje(p,x));
}
